Subject: bug#29370: 27.0.50; C-g hang

From: Eli Zaretskii <[email-masked]>
Date: Tue, 21 Nov 2017 17:34:41 +0200

> From: Richard Stallman <[email-masked]>
> Date: Mon, 20 Nov 2017 16:52:00 -0500
> 
> It hung again.  I did kill -TSTP and got this backtrace.
> 
> I went to frame 4 and type  finish
> and it never finished.
> 
> I went to frame 10 and typed  return Qnil
> and now it is running ok again.
> 
> However, now C-g always fails to exit the minibuffer.

By "always" you mean even when it doesn't hang Emacs?  If so, can you
show a backtrace in that situation, i.e. Emacs that is not hung, but
with cursor in the minibuffer that would stay there if you type C-g?

> #0  __lll_lock_wait ()
>     at ../nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S:135
> #1  0x00007ffff2bfe649 in _L_lock_909 ()
>    from /lib/x86_64-linux-gnu/libpthread.so.0
> #2  0x00007ffff2bfe470 in __GI___pthread_mutex_lock (
>     mutex=0xcb3420 <global_lock>) at ../nptl/pthread_mutex_lock.c:79
> #3  0x0000000000684676 in sys_mutex_lock (mutex=0xcb3420 <global_lock>)
>     at systhread.c:106
> #4  0x0000000000682fc3 in acquire_global_lock (self=0xcb3220 <main_thread>)
>     at thread.c:100
> #5  0x00000000006839b9 in really_call_select (arg=0x7fffffffb010)
>     at thread.c:576
> #6  0x00000000005e071f in flush_stack_call_func (
>     func=0x6838eb <really_call_select>, arg=0x7fffffffb010) at alloc.c:5222
> #7  0x0000000000683a3e in thread_select (func=0x413520 <pselect@plt>, 
>     max_fds=9, rfds=0x7fffffffb110, wfds=0x7fffffffb190, efds=0x0, 
>     timeout=0x7fffffffb720, sigmask=0x0) at thread.c:595
> #8  0x00000000006ac32e in xg_select (fds_lim=9, rfds=0x7fffffffb770, 
>     wfds=0x7fffffffb7f0, efds=0x0, timeout=0x7fffffffb720, sigmask=0x0)
>     at xgselect.c:117
> #9  0x000000000066090b in wait_reading_process_output (time_limit=2, nsecs=0, 
>     read_kbd=1, do_display=true, wait_for_cell=XIL(0), wait_proc=0x0, 
>     just_wait_proc=0) at process.c:5375
> #10 0x0000000000421acd in sit_for (timeout=make_number(2), reading=false, 
>     display_option=2) at dispnew.c:5793

Can you show what's in recent_keys, when Emacs is stuck ("hung") like
this?  Also, do you remember if, before "kill -TSTP" you typed C-g
once or more than once?

Thanks.